<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exslt="http://exslt.org/dates-and-times"
  xmlns:func="http://exslt.org/functions"
  xmlns:dp="http://www.datapower.com/extensions"
  exclude-result-prefixes="dp exslt func xsl"
>
  <xsl:output omit-xml-declaration="yes" method="xml" />

  <xsl:function name="func:pow2">
    <xsl:param name="n" />
    <xsl:choose>
      <xsl:when test="$n = 0">
        <!--<func:result select="1" />-->
        <xsl:value-of select="1" />
      </xsl:when>
      <xsl:otherwise>
        <!--<func:result select="2*func:pow2($n - 1)" />-->
        <xsl:value-of select="2*func:pow2($n - 1)" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:function>

  <xsl:function name="func:gen">
    <xsl:param name="x" />
    <xsl:param name="s" />
    <xsl:param name="l" />
    <xsl:choose>
      <xsl:when test="$l &gt; 0">
        <!--<func:result>-->
          <xsl:element name="xsl:choose">
            <xsl:element name="xsl:when">
              <xsl:attribute name="test">$t &lt;
              <xsl:value-of select="$x - 1" />
              </xsl:attribute>
              <xsl:copy-of
              select="func:gen($x - $s,floor($s div 2),$l - 1)" />
            </xsl:element>
            <xsl:element name="xsl:when">
              <xsl:attribute name="test">$t &gt;
              <xsl:value-of select="$x + 1" />
              </xsl:attribute>
              <xsl:copy-of
              select="func:gen($x + $s,floor($s div 2),$l - 1)" />
            </xsl:element>
            <xsl:element name="xsl:otherwise">
            <xsl:value-of select="$x" />
            ,
            <xsl:element name="xsl:text"></xsl:element>
            </xsl:element>
          </xsl:element>
        <!--</func:result>-->
      </xsl:when>
      <xsl:otherwise>
        <!--<func:result>-->
          <xsl:element name="xsl:text">,</xsl:element>
        <!--</func:result>-->
      </xsl:otherwise>
    </xsl:choose>
  </xsl:function>

  <xsl:template match="/">
    <xsl:variable name="p" select="func:pow2(.)" />

    <xsl:element name="xsl:stylesheet">
      <xsl:attribute name="version">1.0</xsl:attribute>
      <xsl:namespace name="xs">http://www.w3.org/2001/XMLSchema</xsl:namespace>
      <xsl:element name="xsl:template">
        <xsl:attribute name="match">/ts</xsl:attribute>
        <xsl:element name="xsl:for-each">
          <xsl:attribute name="select">t</xsl:attribute>
          <xsl:element name="xsl:variable">
            <xsl:attribute name="name">t</xsl:attribute>
            <xsl:attribute name="select">xs:integer(.)</xsl:attribute>      
          </xsl:element>
          <xsl:copy-of select="func:gen(2*$p,$p,.)" />
        </xsl:element>
      </xsl:element>
    </xsl:element>
  </xsl:template>
</xsl:stylesheet>
