<xsl:stylesheet version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exslt="http://exslt.org/dates-and-times"
  xmlns:func="http://exslt.org/functions"
  xmlns:dp="http://www.datapower.com/extensions"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
  exclude-result-prefixes="dp exslt func"
>
  <xsl:output omit-xml-declaration="yes" method="xml"/>

  <xsl:function name="func:pow2">
    <xsl:param name="n"/>
    <xsl:choose>
      <xsl:when test="$n = 0">
        <!--<func:result select="1"/>-->
        <xsl:value-of select="1"/>
      </xsl:when>
      <xsl:otherwise>
        <!--<func:result select="2*func:pow2($n - 1)"/>-->
        <xsl:value-of select="2*func:pow2($n - 1)"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:function>

  <xsl:function name="func:gen">
    <xsl:param name="fst"/>
    <xsl:param name="lst"/>

    <xsl:choose>
      <xsl:when test="$fst=$lst">
        <!--<func:result>-->
          <t><xsl:value-of select="$lst"/></t>
        <!--</func:result>-->
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="mid" select="floor(($fst+$lst) div 2)"/>
        <!--<func:result>-->
          <xsl:copy-of select="func:gen($fst,$mid)"/>
          <xsl:copy-of select="func:gen($mid+1,$lst)"/>
        <!--</func:result>-->
      </xsl:otherwise>
    </xsl:choose>
    
  </xsl:function>

  <xsl:template match="/">
    <xsl:variable name="p" select="4*func:pow2(.)"/>
    <ts>
    <xsl:copy-of select="func:gen(2,$p -2)"/>
    </ts>
  </xsl:template>
</xsl:stylesheet>
